Foreman - Bug #32776

Host api request fails when thin=true and per_page=all

06/10/2021 02:30 PM - Tomer Brisker

Status: Closed
Priority: Normal
Assignee: Dominik Matoulek
Category: Inventory
Target version: 251
Difficulty: Fixed in Releases: 2.5.1,3.0.0
Triaged: No Found in Releases:
Bugzilla link: 1969263 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/8595,
https://github.com/theforeman/foreman/p
ull/8616
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1969263

Description of problem: Host api with per_page=all and thin=true raise an error. here is sample curl request

1. curl -u admin:Password 'https://satellite.example.com/api/v2/hosts?per_page=all&thin=true&page=2' {
"error": {"message":"Internal Server Error: the server was unable to finish the request. This may be caused by unavailability of
some required service, incorrect API call or a server-side bug. There may be more information in the server's logs."}

}

Version-Release number of selected component (if applicable):

How reproducible: Always

Steps to Reproduce:
1. Log in to the satellite

Satelliete 6.9

2. Access the API https://satellite.example.com/api/v2/hosts?per_page=all&thin=true&page=2

Actual results: fails with error
Expected results: It should return host record

Additional info: This issue is only in satellite 6.9

Related issues:
Related to Foreman - Refactor #29909: Support fetching all records in API

Closed

Associated revisions

Revision 52a3d1ee - 06/22/2021 08:12 AM - Dominik Matoulek

Fixes #32776 - Fixing subtotal count at Hosts controller

Foreman uses will_paginate gem for pagination. When the user wants
all results in one page by API, this gem is not used.

That causes interferences with thin parameter at the Hosts controller.
When the thin parameter is used there method call 'total_entries' that
is method from will_paginate gem. It's works great until user wants all
results in page. In that case will_paginate gem is not used. Logically
is causes NoMethodError. This PR fixes it by calling size instead.

History

#1 - 06/10/2021 02:33 PM - Tomer Brisker
- Related to Refactor #29909: Support fetching all records in APl added

05/18/2024
https://bugzilla.redhat.com/show_bug.cgi?id=1969263
https://satellite.example.com/api/v2/hosts?per_page=all&thin=true&page=2

#2 - 06/11/2021 07:44 AM - Dominik Matoulek

- Assignee set to Dominik Matoulek

#3 - 06/16/2021 07:55 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/8595 added

#4 - 06/22/2021 08:12 AM - The Foreman Bot
- Fixed in Releases 3.0.0 added

#5 - 06/22/2021 08:12 AM - The Foreman Bot
- Fixed in Releases deleted (3.0.0)

#6 - 06/22/2021 08:41 AM - Tomer Brisker
- Fixed in Releases 3.0.0 added

#7 - 06/22/2021 09:08 AM - Dominik Matoulek
- Status changed from Ready For Testing to Closed

Applied in changeset foreman|52a3d1ee7a68c36cdf1{5bb8b6c99f25b1dab539.

#8 - 06/23/2021 09:52 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/8616 added

#9 - 06/23/2021 09:53 AM - Tomer Brisker

- Target version set to 2.5.1

#10 - 06/23/2021 12:24 PM - Tomer Brisker
- Fixed in Releases 2.5.1 added
